<?php
/**
 * click5 Theme Customizer
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}


if ( ! function_exists( 'click5_theme_customize_register' ) ) {

	function click5_theme_customize_register( $wp_customize ) {

		$wp_customize->add_section( 'click5_theme_layout_options', array(
			'title'       => __( 'Theme Layout Settings', 'click5' ),
			'capability'  => 'edit_theme_options',
			'description' => __( 'Container width and sidebar defaults', 'click5' ),
			'priority'    => 160,
		) );

		
		function click5_theme_slug_sanitize_select( $input, $setting ){

			$input = sanitize_key( $input );

			$choices = $setting->manager->get_control( $setting->id )->choices;

			return ( array_key_exists( $input, $choices ) ? $input : $setting->default );                

		}

		$wp_customize->add_setting( 'click5_container_type', array(
			'default'           => 'container',
			'type'              => 'theme_mod',
			'sanitize_callback' => 'click5_theme_slug_sanitize_select',
			'capability'        => 'edit_theme_options',
		) );

		$wp_customize->add_control(
			new WP_Customize_Control(
				$wp_customize,
				'click5_container_type', array(
					'label'       => __( 'Container Width', 'click5' ),
					'description' => __( 'Choose between Bootstrap\'s container and container-fluid', 'click5' ),
					'section'     => 'click5_theme_layout_options',
					'settings'    => 'click5_container_type',
					'type'        => 'select',
					'choices'     => array(
						'container'       => __( 'Fixed width container', 'click5' ),
						'container-fluid' => __( 'Full width container', 'click5' ),
					),
					'priority'    => '10',
				)
		) );

	}
}
add_action( 'customize_register', 'click5_theme_customize_register' );


if ( ! function_exists( 'click5_customize_preview_js' ) ) {
	function click5_customize_preview_js() {
		wp_enqueue_script( 'click5_customizer', get_template_directory_uri() . '/js/customizer.js',
			array( 'customize-preview' ), '20130508', true
		);
	}
}
add_action( 'customize_preview_init', 'click5_customize_preview_js' );
