<?php
/**
 * Theme basic setup.
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

if ( ! isset( $content_width ) ) {
	$content_width = 640;
}

add_action( 'after_setup_theme', 'click5_setup' );

if ( ! function_exists ( 'click5_setup' ) ) {

	function click5_setup() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support( 'title-tag' );

		register_nav_menus( array(
			'primary' => __( 'Primary Menu', 'click5' ),
			'footer' => __( 'Footer Menu', 'click5' ),
			'social-media' => __( 'Social Media Menu', 'click5' ),
		) );

		add_theme_support( 'html5', array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
		) );


		add_theme_support( 'post-thumbnails' );

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support( 'post-formats', array(
			'aside',
			'image',
			'video',
			'quote',
			'link',
		) );

	}
}


add_filter( 'excerpt_more', 'click5_custom_excerpt_more' );

if ( ! function_exists( 'click5_custom_excerpt_more' ) ) {

	function click5_custom_excerpt_more( $more ) {
		if ( ! is_admin() ) {
			$more = '';
		}
		return $more;
	}
}

add_filter( 'wp_trim_excerpt', 'click5_all_excerpts_get_more_link' );

if ( ! function_exists( 'click5_all_excerpts_get_more_link' ) ) {

	function click5_all_excerpts_get_more_link( $post_excerpt ) {
		if ( ! is_admin() ) {
			$post_excerpt = $post_excerpt . ' [...]<p><a class="btn btn-outline-secondary click5-read-more-link" href="' . esc_url( get_permalink( get_the_ID() ) ) . '">' . __( 'Read More...',
			'click5' ) . '</a></p>';
		}
		return $post_excerpt;
	}
}
