<?php
/**
 * Single post partial template.
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

$primary_category = get_primary_category(get_the_ID());
$primary_category = get_term($primary_category);
?>

<article <?php post_class('news'); ?> id="post-<?php the_ID(); ?>">
	<div class="d-flex justify-content-between align-items-center">
		<span class="category"><a href="/category/<?php echo $primary_category->slug; ?>"><?php echo $primary_category->name; ?></a></span>

		<div class="read-time d-flex align-items-center">
			<i class="far fa-clock"></i>
			<?php echo get_reading_time(get_the_content()); ?>
		</div>
	</div>

	<?php the_title( '<h2 class="post-title">', '</h2>' ); ?>

	<div class="author d-flex justify-content-start align-items-center">
		<p>Published by <?php echo get_the_author(); ?></p>
		<time>on <?php echo get_the_date('F j, Y'); ?></time>
	</div>

	<div class="entry-content">
		<?php the_content(); ?>
	</div>
</article>