<?php
/**
 * Post rendering content according to caller of get_template_part.
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

$primary_category = get_primary_category(get_the_ID());
$primary_category = get_term($primary_category);
?>

<div class="news col-lg-4 col-md-6 col-sm-12" id="post-<?php the_ID(); ?>">
	<a href="<?php echo esc_url( get_permalink() ) ?>">
		<div class="content">
			<span class="category <?php echo $primary_category->slug; ?>"><?php echo $primary_category->name; ?></span>
			<h2><?php echo get_the_title(); ?></h2>

			<div class="author d-flex justify-content-between align-items-center">
				<p><?php echo get_the_author(); ?></p>
				<time><?php echo get_the_date('F j, Y'); ?></time>
			</div>
			
			<div class="text">
				<p><?php echo mb_substr(strip_tags(get_the_content()), 0, 220, "UTF-8").'...'; ?></p>
			</div>
		</div>

		<div class="more">
			<p><span>Read More</span></p>
		</div>
	</a>
</div>