<?php
/**
 * Template Name: Contact
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

get_header();
$container = get_theme_mod( 'click5_container_type' );
?>

<div class="wrapper d-flex align-items-end bg-image" style="background-image: url('<?php echo check_background(); ?>');" id="hero-sub">
    <div class="<?php echo esc_attr( $container ); ?>">
        <div class="row">
            <div class="col-lg-12 item text-center">
                <h1><?php the_title(); ?></h1>
            </div>
        </div>
    </div> 
</div> 

<div class="wrapper" id="contact-page">
	<div class="<?php echo esc_attr( $container ); ?>">
		<div class="row">
			<div class="content col-lg-4 col-md-5 col-sm-12">
				<?php the_content(); ?>
			</div>

			<div class="form col-lg-8 col-md-7 col-sm-12">
				<?php echo do_shortcode('[contact-form-7 id="5" title="Contact Form"]'); ?>
			</div>
		</div>
    </div>
    
    <div class="<?php echo esc_attr( $container ); ?>">
		<div class="row">
            <div class="col-sm-12">
                <iframe class="mt-5" style="border: 0;" tabindex="0" src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2970.1419232075177!2d-87.63975204862042!3d41.88980477911935!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x880e2cb6117bac9b%3A0x79511d8ad352bf8f!2s351%20W%20Hubbard%20St%20%23406%2C%20Chicago%2C%20IL%2060654%2C%20USA!5e0!3m2!1sen!2spl!4v1585748485919!5m2!1sen!2sus" width="100%" height="450" frameborder="0" allowfullscreen="allowfullscreen" aria-hidden="false"><span data-mce-type="bookmark" style="display: inline-block; width: 0px; overflow: hidden; line-height: 0;" class="mce_SELRES_start">﻿</span></iframe>
            </div>
        </div>
    </div>
</div>

<?php get_footer(); ?>
