<?php
/**
 * The template for displaying search results pages.
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

get_header();

$container   = get_theme_mod( 'click5_container_type' );

?>

<div class="wrapper" id="search-wrapper">

	<div class="<?php echo esc_attr( $container ); ?>" id="content" tabindex="-1">

		<div class="row">

			<main class="col-md-8" id="main"> 

				<?php if ( have_posts() ) : ?>

					<header class="page-header">
						
							<h1 class="page-title"><?php printf(
							 esc_html__( 'Search Results for: %s', 'click5' ),
								'<span>' . get_search_query() . '</span>' ); ?></h1>

					</header>

					<?php while ( have_posts() ) : the_post(); ?>

						<?php
						get_template_part( 'loop-templates/content', 'search' );
						?>

					<?php endwhile; ?>

				<?php else : ?>

					<?php get_template_part( 'loop-templates/content', 'none' ); ?>

				<?php endif; ?>

				<?php click5_pagination(); ?>

			</main>

		<?php get_sidebar(); ?>

	</div>

</div>

</div>

<?php get_footer(); ?>
