<?php
/**
 * The template for displaying all single posts.
 *
 * @package click5
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

get_header();
$container = get_theme_mod( 'click5_container_type' );
?>

<div class="wrapper d-flex align-items-end bg-image" style="background-image: url(<?php bloginfo('template_url'); ?>/img/hero.jpg)" id="hero-sub">
    <div class="<?php echo esc_attr( $container ); ?>">
        <div class="row">
            <div class="col-lg-12 item text-center">
                <h1>Blog</h1>
            </div>
        </div>
    </div> 
</div> 

<div class="wrapper" id="single-wrapper">
	<div class="<?php echo esc_attr( $container ); ?>" id="content" tabindex="-1">
		<div class="row">
			<main class="col-12" id="main">

				<?php while ( have_posts() ) : the_post(); ?>

					<?php get_template_part( 'loop-templates/content', 'single' ); ?>

					<?php
						if ( comments_open() || get_comments_number() ) :
							comments_template();
						endif;
					?>

				<?php endwhile; ?>

			</main>

			<div class="col-12">
				<a href="<?php the_permalink(12); ?>" class="back"><span>Back to <?php echo get_the_title(12); ?></span></a>
			</div>
		</div>
	</div>
</div>

<div class="wrapper" id="recent-posts">
	<div class="container">
		<div class="row">
			<div class="col-12">
				<h2 class="pt-0">Recent Posts</h2>
			</div>
		</div>
	</div>

	<div class="container c-2">
		<?php
			$news = array(
				'posts_per_page' => 3,
				'post__not_in' => array( $post->ID )
			);

			$the_query = new WP_Query( $news );

			if($the_query->have_posts()) :
				$primary_category = get_primary_category(get_the_ID());
				$primary_category = get_term($primary_category);
		?>

		<div class="row">
			<?php while($the_query->have_posts()) : $the_query->the_post(); ?>

			<div class="news col-lg-4 col-md-6 col-sm-12">
				<a href="<?php the_permalink(); ?>">
					<div class="content">
						<span class="category <?php echo $primary_category->slug; ?>"><?php echo $primary_category->name; ?></span>
						<h2><?php echo get_the_title(); ?></h2>

						<div class="author d-flex justify-content-between align-items-center">
							<p><?php echo get_the_author(); ?></p>
							<time><?php echo get_the_date('F j, Y'); ?></time>
						</div>
						
						<div class="text">
							<p><?php echo mb_substr(strip_tags(get_the_content()), 0, 220, "UTF-8").'...'; ?></p>
						</div>
					</div>

					<div class="more">
						<p><span>Read More</span></p>
					</div>
				</a>
			</div>

			<?php endwhile; ?>
		</div>

		<?php endif; ?>
		<?php wp_reset_query();?>
	</div>
</div>

<?php get_footer(); ?>